/****
 *
 * Exemplo:Hanoi.c
 *
 * Captulo:3
 * Seo: 3.5.2
 *
 * Demonstra: Soluo para o problema das Torres de Hani.
 *
 ****/

#include <stdio.h>

extern   void  TorresDeHanoi( int, char, char, char );

main()
{
   int 	numeroDeDiscos;

   printf("Introduza o numero de discos: "); /* Solicita dado ao usurio   */
   scanf("%d", &numeroDeDiscos); /* No esquea de passar o endereo aqui! */
   printf("\n\n");

   TorresDeHanoi(numeroDeDiscos, 'A', 'C', 'B');
}

/****
 *
 * Funo TorresDeHanoi()
 *
 * Descrio: Resolve o problema das Torres de Hani.
 *
 * Parmetros:
 *      numeroDeDiscos (entrada): o numero de discos
 *      hasteOrigem (entrada): a haste onde os discos se encontram inicialmente
 *      hasteDestino (entrada): a haste onde os discos devero estar ao final
 *      hasteAuxiliar (entrada): a haste que auxilia o movimento
 *
 * Retorno: Nada.
 *
 ****/

void TorresDeHanoi( int numeroDeDiscos,  /* Este estilo de cabealho       */
                    char hasteOrigem,    /* apropriado para funes cujos   */
                    char hasteDestino,   /* cabealhos so longos. Tambm  */
                    char hasteAuxiliar ) /* til para comentar cada         */
                                         /* parmetro na declarao da funo.*/
                                         /* Este ltimo no  necessrio      */
                                         /* neste caso.	                      */
{
   if (numeroDeDiscos == 1){
      printf( "Mova o disco 1 da haste %c para a haste %c\n", /* Passo 1:  */
              hasteOrigem, hasteDestino );	/* Imprime e encerra */
      return;
   }

	     /* Move os n-1 discos de A para B usando C como auxiliar (Passo 2)  */
   TorresDeHanoi(numeroDeDiscos-1,hasteOrigem,hasteAuxiliar,hasteDestino);
   printf( "Mova o disco %d da haste %c para a haste %c\n", /* Move ltimo    */
           numeroDeDiscos, hasteOrigem, hasteDestino );    /* disco de A para */
								                           /* C (Passo 3).    */

        /* Move os n-1 discos de B para C usando A como auxiliar (Passo 4)  */
   TorresDeHanoi(numeroDeDiscos-1,hasteAuxiliar,hasteDestino,hasteOrigem);
}

/************* Exemplo da Execuo do Programa *************
 *                                                         *
 * Introduza o numero de discos: 4                         *
 *                                                         *
 * Mova o disco 1 da haste A para a haste B                *
 * Mova o disco 2 da haste A para a haste C                *
 * Mova o disco 1 da haste B para a haste C                *
 * Mova o disco 3 da haste A para a haste B                *
 * Mova o disco 1 da haste C para a haste A                *
 * Mova o disco 2 da haste C para a haste B                *
 * Mova o disco 1 da haste A para a haste B                *
 * Mova o disco 4 da haste A para a haste C                *
 * Mova o disco 1 da haste B para a haste C                *
 * Mova o disco 2 da haste B para a haste A                *
 * Mova o disco 1 da haste C para a haste A                *
 * Mova o disco 3 da haste B para a haste C                *
 * Mova o disco 1 da haste A para a haste B                *
 * Mova o disco 2 da haste A para a haste C                *
 * Mova o disco 1 da haste B para a haste C                *
 *                                                         *
 ***********************************************************/

