/****
 *
 * Exemplo: va_arg2.c
 *
 * Captulo: 3
 * Seo: 3.4
 *
 * Demonstra: Funes com listas de argumentos variveis.
 *
 ****/

#include <stdio.h>
#include <stdarg.h>

/***
 *
 * Calcula a mdia de um nmero indeterminado de doubles
 * O primeiro argumento informa o nmero de valores a seguir
 *
 ***/
double Media(int arg1, ...)
{
   int     	nValores = arg1, i;
   va_list 	argumentos;
   double 	soma = 0.0;

   va_start(argumentos, arg1); 	/* Inicializa lista de argumentos variveis */

			/* L cada argumento e acrescenta  soma */
   for (i = 0; i < nValores; ++i) {
      soma += va_arg(argumentos, double);
   }

   va_end(argumentos);	/* Encerra o processamento dos argumentos */

   return soma/nValores;
}

int main()
{
   printf("A media dos numeros 1.2, 4.5, -2.3 e 9.1 e': %lf\n",
           Media(4, 1.2, 4.5, -2.3, 9.1));

   getchar();
   return 0;
}
