/****
 *
 * Exemplo: strlen.c
 *
 * Captulo: 8
 * Seo: 8.4.3
 *
 * Demonstra: Vrias implementaes possveis de strlen().
 *
 ****/

#include <stdio.h>
#include <string.h>

#define IMPRIME(X) printf("Tamanho do string usando %s: %u\n", #X, X)

size_t  Comprimento1(const char *str)
{
   size_t tamanho = 0;
   long   i = 0;

   while (str[i] != '\0') {
      ++i;
      ++tamanho;
   }

   return tamanho;
}

size_t  Comprimento2(const char *str)
{
   size_t tamanho = 0;

   while (str[tamanho] != '\0')
      ++tamanho;

   return tamanho;
}

size_t  Comprimento3(const char *str)
{
   size_t tamanho = 0;

   while (*str++) {
      ++tamanho;
   }

   return tamanho;
}

int main()
{
   char    *ptr = "um string de comprimento 27";

   IMPRIME(strlen(ptr));
   IMPRIME(Comprimento1(ptr));
   IMPRIME(Comprimento2(ptr));
   IMPRIME(Comprimento3(ptr));

   return 0;
}

