/****
 *
 * Exemplo: ArrayFlexiveis.c
 *
 * Captulo: 9
 * Seo: 9.8
 *
 * Demonstra: Arrays flexveis como membros de estruturas (C99).
 *
 ****/

#include <stdio.h>
#include <stdlib.h>

typedef struct {
   int a;
   int b[];
} tEstrutura;

tEstrutura *F(int N)
{
   tEstrutura *p;
   int        i;

   if (N <= 0)
      return NULL;

      /* A instruo a seguir  equivalente a fazer com que    */
      /* p aponte para uma estrutura do tipo tEstrutura, tendo */
      /* como ltimo elemento um array com N elementos do      */
      /* tipo int, ao invs do array de tamanho indefinido.    */
   p = malloc( sizeof(tEstrutura) + N*sizeof(int) );

   if (!p)
      return NULL; // No houve alocao; no  possvel continuar

   p->a = N; // Atribui o nmero de elementos do array ao campo a

        // Inicia os elementos do array alocado dinamicamente
   for (i = 0; i < N; ++i)
      p->b[i] = i;

   return p;
}

int main(void)
{
   tEstrutura *p;

   p = F(rand()); // A funo rand() gera nmeros aleatrios
                  // (V. Volume II)

   if (!p)
      return 1;

   printf("Numero de elementos processados: %d\n", p->a);

   for (int i = 0; i < p->a; ++i)
      printf("Elemento[%d] = %d\n", i, p->b[i]);

   return 0;
}
