/****
 *
 * Exemplo: LiteraisCompostos2.c
 *
 * Captulo: 9
 * Seo: 9.11
 *
 * Demonstra: Literais compostos (C99).
 *
 ****/

#include <stdio.h>

typedef struct {
           int   a;
           float b;
           char  c;
           char  d[10];
        } tEst;

typedef struct {
           int   a;
           float b;
           char  c;
        } tEst2;

void F(int ar[], unsigned int nElementos)
{
   for (int i = 0; i < nElementos; ++i)
      printf("ar[%d] = %d\n", i, ar[i]);
}

void F2(tEst2 *est)
{
   printf("est->a = %d\n", est->a);
   printf("est->b = %f\n", est->b);
   printf("est->c = %c\n", est->c);
}


int main()
{
   int *p = (int []){ 1, 2 }; // p aponta para um arranjo annimo de
                              // ints com dois elementos iniciados
                              // com 1 e 2


   tEst *pEst = &(tEst) {.b = 3.5, .d[2] = 'C'};

   int *pInt = &(int){-2}; // pInt aponta para uma varivel annima do
                           // tipo int iniciada com -2

   const char *p1 = (const char []){'C', 'B', 'F'};
   const char *p2 = (const char []){'C', 'B', 'F'};

   p[1] = -2;
   pEst->d[0] = 'u';
   *pInt = 10;

   if (p1 == p2)
      printf("Os ponteiros p1 e p2 apontam para a mesma posicao\n");

   F((int []){ -2, 1 }, 2 );

   F2(&(tEst2){ -2, 2.2f, 'B' });

   return 0;
}

