/****
 *
 * Exemplo: PessoasAnos.c
 *
 * Captulo: 7
 * Seo: 9.7
 *
 * Demonstra: Arrays de estruturas.
 *
 ****/

#include <stdio.h>
#include <stdlib.h>

#define DEBUG  1

#if DEBUG
#define ASSERT( x )  if (!(x) ) {\
	       printf("A condicao %s na linha %d do arquivo %s falhou", \
			      #x, __LINE__, __FILE__); \
           exit(1); \
		}
#else
#define ASSERT( x )  0;
#endif

typedef  struct  {
     	  	char   nome[30];
     	  	short  dia, mes, ano;
        } tPessoa;

unsigned PessoasEntreAnos1( tPessoa pessoas[],
                                    unsigned  numeroDePessoas,
                                    unsigned anoInicial,
                                    unsigned anoFinal )
{
   unsigned  i, contador = 0;


   ASSERT(anoInicial < anoFinal)

   for (i = 0; i < numeroDePessoas; i++){
      if ( (pessoas[i].ano > anoInicial) &&
           (pessoas[i].ano < anoFinal) ){
         contador++;
      }
   }

   return  contador;
}

unsigned PessoasEntreAnos2( tPessoa pessoas[],
                                    unsigned  numeroDePessoas,
                                    unsigned anoInicial,
                                    unsigned anoFinal )
{
   unsigned  i, contador = 0;

   ASSERT(anoInicial < anoFinal)

   for (i = 0; i < numeroDePessoas; pessoas++, i++){
      if ( (pessoas->ano > anoInicial) &&
           (pessoas->ano < anoFinal) ){
         contador++;
      }
   }

   return  contador;
}

int main(void)
{
   tPessoa  arrayDePessoas[20];

/*   ...	/ Atribuio de valores aos registros do array */

   printf( "O numero de pessoa nascidas entre 1960 e 1980  %d\n",
	       PessoasEntreAnos1(arrayDePessoas, 20, 1960,1980) );

   return 0;
}
