/****
 *
 * Exemplo: qsort1.c
 *
 * Captulo: 11
 * Seo: 11.9.1
 *
 * Demonstra: O uso da funo qsort().
 *
 ****/

#include <stdio.h>
#include <stdlib.h>

int ComparaIntsCrescente(const void *elem1, const void *elem2)
{
   return *(int *)elem1 - *(int *)elem2;
}

int ComparaIntsDecrescente(const void *elem1, const void *elem2)
{
   return *(int *)elem2 - *(int *)elem1;
}

int main(void)
{
   int  arrayDeInts[] = {12, 55, 21, 1, 6, 8, 17, 220, 5, 83};
   int  i, tamanhoAr;

   tamanhoAr = sizeof(arrayDeInts)/sizeof(arrayDeInts[0]);

   printf("Ordem original:\n");
   for (i=0; i < tamanhoAr; i++) {
     printf(" %d ", arrayDeInts[i]);
   }

   qsort(arrayDeInts, tamanhoAr, sizeof(int), ComparaIntsCrescente);

   printf("\n\nOrdem crescente:\n");
   for (i=0; i < tamanhoAr; i++) {
     printf(" %d ", arrayDeInts[i]);
   }

   qsort(arrayDeInts, tamanhoAr, sizeof(int), ComparaIntsDecrescente);

   printf("\n\nOrdem decrescente:\n");
   for (i=0; i < tamanhoAr; i++) {
     printf(" %d ", arrayDeInts[i]);
   }

   return 0;
}
