/****
 *
 * Exemplo: vfprintf.c
 *
 * Captulo: 12
 * Seo: 12.10.2
 *
 * Demonstra: O uso da funo vfprintf().
 *
 ****/

#include <stdio.h>
#include <stdarg.h>

int ExemploDe_vfprintf(FILE *stream, const char *formato, ...)
{
   va_list 	argumentos;
   int 	retorno;

      /* Acessa a lista de argumentos variveis representada por */
      /* "..." usando uma varivel do tipo va_list e chama a     */
      /* funo vfprintf() passando esta varivel como argumento */
   va_start(argumentos, formato);
   retorno = vfprintf(stream, formato, argumentos);
   va_end(argumentos);

   return retorno;
}

int main(void)
{
   FILE *stream;
   int   umInteiro = 30;
   float umFloat = 7.45f;
   char  umString[20] = "Teste";

   stream = fopen("Teste.txt", "w+");

   if (!stream) {
      perror("Arquivo nao pode ser criado.");
      return 1;
   }

   ExemploDe_vfprintf( stream, "%d %f %s",
                       umInteiro, umFloat, umString );

   fscanf(stream, "%d %f %s", &umInteiro, &umFloat, umString);

   printf("%d %f %s\n", umInteiro, umFloat, umString);

   fclose(stream);

   return 0;
}
