/****
 *
 * Exemplo: vsscanf.c
 *
 * Captulo: 12
 * Seo: 12.10.3
 *
 * Demonstra: O uso da funo vsscanf().
 *
 ****/

#include <stdio.h>
#include <stdarg.h>

int Exemplo_vsscanf(const char *s, const char *formato, ...)
{
   int     nValoresAtribuidos;
   va_list args;

      /* Acessa a lista de argumentos variveis representada por */
      /* "..." usando uma varivel do tipo va_list e chama a     */
      /* funo vsscanf() passando esta varivel como argumento  */
   va_start(args, formato);
   nValoresAtribuidos = vsscanf(s, formato, args);
   va_end(args);

   return nValoresAtribuidos;
}

int main(void)
{
   int   umInt, nValoresLidos;
   float umFloat;
   char  umChar;
   char  entrada[] = "12 3.1415 X algo mais";

   nValoresLidos = Exemplo_vsscanf( entrada, "%d %f %c",
                                    &umInt, &umFloat, &umChar );

   printf("\nString onde e' feita a leitura: \n\t%s", entrada);
   printf( "\n\nNumero de valores lidos e atribuidos: %d",
           nValoresLidos );

   if (3 == nValoresLidos) {
      printf( "\n\nValores lidos:\n \t%d, %f e %c", umInt,
              umFloat, umChar );
   }

   return 0;
}
