/****
 *
 * Exemplo: ComparaOperadores.c
 *
 * Captulo: 13
 * Seo: 13.3.1
 *
 * Demonstra: Comparao entre operadores
 *            lgicos e operadores sobre bits.
 *
 ****/

#include <stdio.h>
#include <limits.h>

void   RepresentacaoBinaria(int  numero)
{
   int           i, bit, numeroDeBits;
   unsigned int  mascara; /* A mscara deve ser unsigned aqui */

       /* Cada byte contm um nmero de bits igual a CHAR_BIT */
   numeroDeBits  = CHAR_BIT*sizeof(int);

       /* Coloca 1 na posio mais  esquerda da  */
       /* mscara. Todos os outros bits tero 0s. */
   mascara = 0x1 << (numeroDeBits - 1);

     /* Imprime cada bit a partir da esquerda do nmero (parmetro) */
   for (i = 1; i <= numeroDeBits; i++) {
      bit = (numero & mascara) ? 1 : 0;
      printf("%d", bit);
      if (i % 4 == 0)   /* Separa bits em seqncias de quatro para */
         printf("   ");	/* melhor visualizao da representao     */

      mascara >>= 1;  /* Move bit com valor 1 da mscara */
                      /*  uma posio para a direita     */
   }
}

int main(void)
{
   int x, y, teste;
   double *d1, *d2;
   char c1, c2;

   x = 0;
   if (x & 10/x)
      printf("\n x e' diferente de 0.");
   else
      printf("\n x e' igual a 0.");

   while (1) {
      printf("\n\nIntroduza dois numeros inteiros: ");
      teste = scanf("%d %d", &x, &y);
      if (teste != 2) break;

      printf("\nRepresentacao de %d:\n", x);
      RepresentacaoBinaria(x);
      printf("\nRepresentacao de %d:\n", y);
      RepresentacaoBinaria(y);

      printf("\nx && y = %d", x && y);
      printf("\nx & y = %d", x & y);
      printf("\nx || y = %d", x || y);
      printf("\nx | y = %d", x | y);
      printf("\n!x = %d", !x);
      printf("\n~x = %d", ~x);
   }

   return 0;
}
